Function.prototype.curry = function() {
  var theFunction = this;
  var cacheArguments = Array.prototype.slice.apply(arguments);
  
  return function() {
    return theFunction.apply(this, 
      cacheArguments.concat(
        Array.prototype.slice.apply(arguments))); 
  }
}

var log = function(level, date, msg) {
  console.log(level + ' ' + date + ' ' + msg);
}

var today = new Date();

log('warning', today, 'starting...');
log('warning', today, 'running...');

var logWarningToday = log.curry('warning', today);
logWarningToday('staring...');
logWarningToday('running...');