Function.prototype.curry = function() {
  var theFunction = this;
  var cacheArguments = Array.prototype.slice.apply(arguments);
  
  return function() {
    return theFunction.apply(this, 
      cacheArguments.concat(
        Array.prototype.slice.apply(arguments))); 
  }
}

var greetWith = function(name) {
  console.log(this + ' ' + name);
}

greetWith.call('hello', 'Joe');

var greetJoeWith = greetWith.curry('Joe');
greetJoeWith.call('hello');